rules:
- id: "glappsec_insecure_tls-go"
  patterns:
  - pattern-either:
    - pattern: |
        tls.Config{..., CipherSuites: []$SLICE{..., $CIPHERS, ...}, ...}
    - pattern: |
        tls.CipherSuite{..., ID: $CIPHERS, ...}
  - metavariable-regex:
      metavariable: "$CIPHERS"
      regex: "tls\\.(?!TLS_AES_256_GCM_SHA384|TLS_AES_128_GCM_SHA256|TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384|TLS_ECDHE_ECDSA_WITH_AES_256_GCM_SHA384|TLS_ECDHE_RSA_WITH_AES_128_GCM_SHA256|TLS_ECDHE_ECDSA_WITH_AES_128_GCM_SHA256)"
  message: >
    Usage of a cryptographically insecure cipher suite has been detected. 
    It is recommended that alternative ciphers be used instead. 
    Consult GitLab's secure coding guidelines for more information: 
    https://docs.gitlab.com/ee/development/secure_coding_guidelines.html#ciphers
  metadata:
    confidence: HIGH
    references:
      - https://docs.gitlab.com/ee/development/secure_coding_guidelines.html#tls-minimum-recommended-version
    vulnerability_class:
      - TLS minimum recommended version
  severity: WARNING
  languages:
    - "go"
